/**
 * Created by IntelliJ IDEA.
 * User: mcnanuschi
 * Date: 07.05.11
 * Time: 12:18
 * To change this template use File | Settings | File Templates.
 */

import com.mongodb.*

def params = [host: "localhost", db: "myDemo", coll: "roomplanning"]
Mongo mongo = new Mongo(params.host)
DB db = mongo.getDB(params.db)
DBCollection coll = db.getCollection(params.coll)
coll.drop()

BasicDBObject doc = new BasicDBObject()
def DATUM, ANFANG, ENDE
def f = new File("data/dmdw-data.csv");
assert f.size() > 0
def counter = 0

f.readLines("UTF-8").each { line ->
    line.normalize()
    def item = []
    if (line =~ /Tag;Datum;Anfang;Ende;Raum;Veranstaltungsname;Dozent;Kommentar;/) {
        //do nothing because line has no proper content
    }
    else {
        //prevent from empty datasets
        if (line != ";;;;;;;;") {

            line.split(";").each {
                item << it
            }
            if (item[1] && item[2] && item[3] ) {
                DATUM = new Date().parse("dd.MM.yy", item[1])
                ANFANG = new Date().parse("dd.MM.yy-hh:mm", item[1] + "-" + item[2])
                ENDE = new Date().parse("dd.MM.yy-hh:mm", item[1] + "-" + item[3])
            }
            else {
                DATUM = new Date(0)
                ANFANG = new Date(0)
                ENDE = new Date(0)
            }
            doc.put("Tag", String.format("%ta", DATUM))
            doc.put("Datum", DATUM)
            doc.put("Anfang", ANFANG)
            doc.put("Ende", ENDE)
            doc.put("Raum", (item[4]) ? item[4] : "")
            doc.put("Veranstaltungsname", (item[5]) ? item[5] : "")
            doc.put("Dozent", (item[6]) ? item[6] : "")
            doc.put("Kommentar", (item[7]) ? item[7] : "")
            coll.insert(doc)

            print counter++
            println doc
            doc.clear()
        }
    }
}

println "Inserting complete..."
//tag,datum,anfang,ende,raum, veranstaltungsname,dozent,kommentar
